import { SArray } from 's-array';
import { Alert } from './alerts-model';
/**
 * Controller for the list of alerts.
 */
export declare class AlertsCtrl {
    /**
     * Array signal carrying the list of alerts currently shown.
     */
    readonly alerts: SArray<Alert>;
    private readonly alerts_;
    constructor();
    /**
     * Adds a new alert that is to be shown to the user.
     *
     * @param title title of the alert
     * @param failure details of the alert
     */
    alert(title: string, failure: unknown): void;
    /**
     * Removes the given alert.
     *
     * @param alert alert to be removed, must have been previously created by {@link alert}().
     */
    remove(alert: Alert): void;
}
//# sourceMappingURL=alerts-ctrl.d.ts.map