import { isFailure } from '@fschopp/project-planning-for-you-track';
import { createAlerts } from './alerts-model.js';

/**
 * Controller for the list of alerts.
 */

class AlertsCtrl {
  constructor() {
    this.alerts_ = createAlerts();
    this.alerts = this.alerts_;
  }
  /**
   * Adds a new alert that is to be shown to the user.
   *
   * @param title title of the alert
   * @param failure details of the alert
   */


  alert(title, failure) {
    let message;

    if (isFailure(failure)) {
      message = failure;
    } else if (failure instanceof Error) {
      message = failure.toString();
    } else {
      message = `Unknown error: ${failure}`;
    }

    this.alerts_.push({
      title,
      message
    });
  }
  /**
   * Removes the given alert.
   *
   * @param alert alert to be removed, must have been previously created by {@link alert}().
   */


  remove(alert) {
    this.alerts_.remove(alert);
  }

}

export { AlertsCtrl };
//# sourceMappingURL=alerts-ctrl.js.map
