import { DataSignal } from 's-js';
import { Plain } from '../../utils/s';
export declare type Contributor = YouTrackContributor | ExternalContributor;
export interface ContributorBase {
    readonly type: ContributorKind;
    readonly hoursPerWeek: DataSignal<number>;
}
export declare const enum ContributorKind {
    YOU_TRACK = 0,
    EXTERNAL = 1
}
export interface ExternalContributor extends ContributorBase {
    readonly type: ContributorKind.EXTERNAL;
    readonly name: DataSignal<string>;
    readonly numMembers: DataSignal<number>;
}
export interface YouTrackContributor extends ContributorBase {
    readonly type: ContributorKind.YOU_TRACK;
    readonly id: string;
}
export declare function createContributor(plain: Plain<Contributor>): Contributor;
export declare function createExternalContributor(plain: Plain<ExternalContributor>): ExternalContributor;
export declare function createYouTrackContributor(plain: Plain<YouTrackContributor>): YouTrackContributor;
//# sourceMappingURL=contributor-model.d.ts.map