import { jsonable } from '../../utils/s.js';
import S from 's-js';
import { unreachableCase } from '../../utils/typescript.js';

function createContributor(plain) {
  switch (plain.type) {
    case 0
    /* YOU_TRACK */
    :
      return createYouTrackContributor(plain);

    case 1
    /* EXTERNAL */
    :
      return createExternalContributor(plain);

    default:
      return unreachableCase(plain);
  }
}
function createExternalContributor(plain) {
  return Object.assign({}, createContributorBase(plain), {
    type: 1
    /* EXTERNAL */
    ,
    name: jsonable(S.value(plain.name)),
    numMembers: jsonable(S.value(plain.numMembers))
  });
}
function createYouTrackContributor(plain) {
  return Object.assign({}, createContributorBase(plain), {
    type: 0
    /* YOU_TRACK */
    ,
    id: plain.id
  });
}

function createContributorBase(plain) {
  return {
    type: plain.type,
    hoursPerWeek: jsonable(S.value(plain.hoursPerWeek))
  };
}

export { createContributor, createExternalContributor, createYouTrackContributor };
//# sourceMappingURL=contributor-model.js.map
