import { mapSample } from 's-array';
import { createElement, createTextNode, setAttribute, assign, S, content, insert } from 'surplus';
import { sortableBindSarray, withClassIff, bindString, focusOnChangeToValue, bindNumber } from '../../utils/surplus.js';
import { EXTERNAL_CONTRIBUTOR_VALUE } from './contributors-ctrl.js';
import { MAX_PERSONS_PER_CONTRIBUTORS, INPUT_WIDTH_3_DIGITS, MAX_HOURS_PER_WEEK, ContributorView, DRAGGABLE_HANDLE_CLASS } from '../contributor/contributor-view.js';

const HIDDEN_CLASS = 'd-none';
const SELECT_CLASS = 'custom-select custom-select-sm w-100';
const INPUT_CLASS = 'form-control form-control-sm';
const INPUT_CLASS_RIGHT = 'form-control form-control-sm text-right';
function ContributorsView({
  className,
  ctrl
}) {
  return function () {
    var __, __ul1, __div2, __div2_div1, __div2_div1_div1, __div2_div1_div1_select1, __div2_div1_div1_select1_insert1, __div2_div1_div1_select1_option2, __div2_div1_div1_select1_optgroup3, __div2_div1_div2, __div2_div1_div2_input1, __div2_div1_div2_div2, __div2_div1_div2_div2_button1, __div2_div1_div3, __div2_div1_div3_input1, __div2_div1_div3_div2, __div2_div1_div3_div2_span1, __div2_div1_div4, __div2_div1_div4_input1, __div2_div1_div4_div2, __div2_div1_div4_div2_span1, __div2_button2, __div2_button2_span1;

    __ = createElement("div", null, null);
    __.className = className || '';
    __ul1 = createElement("ul", "list-group mb-3", __);
    __div2 = createElement("div", "list-group-add d-flex", __);
    __div2_div1 = createElement("div", "form-inline flex-grow-1", __div2);
    __div2_div1_div1 = createElement("div", "flex-fill mr-3 mb-1 mb-sm-0", __div2_div1);
    __div2_div1_div1_select1 = createElement("select", null, __div2_div1_div1);
    __div2_div1_div1_select1.className = SELECT_CLASS;
    __div2_div1_div1_select1_insert1 = createTextNode('', __div2_div1_div1_select1);
    __div2_div1_div1_select1_option2 = createElement("option", null, __div2_div1_div1_select1);
    __div2_div1_div1_select1_option2.value = EXTERNAL_CONTRIBUTOR_VALUE;
    __div2_div1_div1_select1_option2.textContent = "External contributor…";
    __div2_div1_div1_select1_optgroup3 = createElement("optgroup", null, __div2_div1_div1_select1);
    __div2_div1_div1_select1_optgroup3.label = "YouTrack Users";
    __div2_div1_div2 = createElement("div", "input-group input-group-sm flex-nowrap flex-fill mr-3 mb-1 mb-sm-0", __div2_div1);
    __div2_div1_div2_input1 = createElement("input", null, __div2_div1_div2);
    __div2_div1_div2_input1.className = INPUT_CLASS;
    __div2_div1_div2_input1.size = 10;
    setAttribute(__div2_div1_div2_input1, "aria-label", "Name of external contributor");
    __div2_div1_div2_div2 = createElement("div", "input-group-append", __div2_div1_div2);
    __div2_div1_div2_div2_button1 = createElement("button", "btn btn-outline-secondary", __div2_div1_div2_div2);
    __div2_div1_div3 = createElement("div", "input-group input-group-sm flex-nowrap mr-3 mb-1 mb-sm-0", __div2_div1);
    __div2_div1_div3_input1 = createElement("input", null, __div2_div1_div3);
    __div2_div1_div3_input1.type = "number";
    __div2_div1_div3_input1.className = INPUT_CLASS_RIGHT;
    __div2_div1_div3_input1.min = "1";
    __div2_div1_div3_input1.max = MAX_PERSONS_PER_CONTRIBUTORS;
    assign(__div2_div1_div3_input1.style, {
      width: INPUT_WIDTH_3_DIGITS
    });
    setAttribute(__div2_div1_div3_input1, "aria-label", "Number of persons");
    __div2_div1_div3_div2 = createElement("div", "input-group-append", __div2_div1_div3);
    __div2_div1_div3_div2_span1 = createElement("span", "input-group-text", __div2_div1_div3_div2);
    __div2_div1_div3_div2_span1.textContent = "👤";
    __div2_div1_div4 = createElement("div", "input-group input-group-sm flex-nowrap mr-3 mb-1 mb-sm-0", __div2_div1);
    __div2_div1_div4_input1 = createElement("input", null, __div2_div1_div4);
    __div2_div1_div4_input1.type = "number";
    __div2_div1_div4_input1.className = INPUT_CLASS_RIGHT;
    __div2_div1_div4_input1.min = "1";
    __div2_div1_div4_input1.max = MAX_HOURS_PER_WEEK;
    assign(__div2_div1_div4_input1.style, {
      width: INPUT_WIDTH_3_DIGITS
    });
    setAttribute(__div2_div1_div4_input1, "aria-label", "Hours per week per person");
    __div2_div1_div4_div2 = createElement("div", "input-group-append", __div2_div1_div4);
    __div2_div1_div4_div2_span1 = createElement("span", "input-group-text", __div2_div1_div4_div2);
    __div2_div1_div4_div2_span1.textContent = "h/week";
    __div2_button2 = createElement("button", "close", __div2);
    __div2_button2_span1 = createElement("span", null, __div2_button2);
    setAttribute(__div2_button2_span1, "aria-hidden", "true");
    __div2_button2_span1.textContent = "+";
    S.effect(function (__current) {
      return content(__ul1, mapSample(ctrl.contributorControllers, itemCtrl => ContributorView({
        "ctrl": itemCtrl
      })), __current);
    }, '');
    S.effect(function (__state) {
      return sortableBindSarray(ctrl.contributors, {
        handle: `.${DRAGGABLE_HANDLE_CLASS}`
      })(__ul1, __state);
    });
    S.effect(function (__state) {
      return withClassIff(() => ctrl.contributors().length === 0, HIDDEN_CLASS)(__ul1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, ctrl.newEntry.id().length === 0 && function () {
        var __;

        __ = createElement("option", null, null);
        __.value = "";
        __.selected = true;
        __.disabled = true;
        __.textContent = "Choose to add";
        return __;
      }());
    }, {
      start: __div2_div1_div1_select1_insert1,
      end: __div2_div1_div1_select1_insert1
    });
    S.effect(function (__current) {
      return content(__div2_div1_div1_select1_optgroup3, Array.from(ctrl.youTrackUserMap().values(), user => function () {
        var __;

        __ = createElement("option", null, null);
        __.value = user.id;
        content(__, user.fullName, "");
        return __;
      }()), __current);
    }, '');
    S.effect(function (__state) {
      return bindString(ctrl.newEntry.id)(__div2_div1_div1_select1, __state);
    });
    S.effect(function (__state) {
      return ctrl.withClassIffExternalContributor(true, HIDDEN_CLASS)(__div2_div1_div1, __state);
    });
    S.effect(function (__state) {
      return bindString(ctrl.newEntry.name)(__div2_div1_div2_input1, __state);
    });
    S.effect(function (__state) {
      return focusOnChangeToValue(ctrl.newEntryType, 1
      /* EXTERNAL */
      )(__div2_div1_div2_input1, __state);
    });
    S.effect(function () {
      __div2_div1_div2_div2_button1.type = "button";

      __div2_div1_div2_div2_button1.onclick = () => ctrl.reset();

      __div2_div1_div2_div2_button1.textContent = "Reset";
    });
    S.effect(function (__state) {
      return ctrl.withClassIffExternalContributor(false, HIDDEN_CLASS)(__div2_div1_div2, __state);
    });
    S.effect(function (__state) {
      return bindNumber(ctrl.newEntry.numMembers)(__div2_div1_div3_input1, __state);
    });
    S.effect(function (__state) {
      return ctrl.withClassIffExternalContributor(false, HIDDEN_CLASS)(__div2_div1_div3, __state);
    });
    S.effect(function (__state) {
      return bindNumber(ctrl.newEntry.hoursPerWeek)(__div2_div1_div4_input1, __state);
    });
    S.effect(function () {
      __div2_button2.type = "button";
      setAttribute(__div2_button2, "aria-label", "Add contributor");

      __div2_button2.onclick = () => ctrl.create();
    });
    return __;
  }();
}

export { ContributorsView };
//# sourceMappingURL=contributors-view.js.map
