import { createElement, createTextNode, content, S, insert } from 'surplus';
import { unreachableCase } from '../../utils/typescript.js';
import { withClassIff } from '../../utils/surplus.js';
import { Action } from '../app/app-ctrl.js';
import { Page } from '../app/app-model.js';
import { ProgressBarView } from '../progress-bar/progress-bar-view.js';

// noinspection ES6UnusedImports

function append(list, additional) {
  return additional === undefined ? list : `${list} ${additional}`;
}

function NavView({
  children,
  className,
  appCtrl
}) {
  return function () {
    var __, __insert1, __a2, __ul3, __ul3_li1, __ul3_li1_a1, __ul3_li1_a1_span2, __ul3_li2, __ul3_li2_a1, __ul3_li2_a1_span2, __ul3_li2_a1_span3, __ul3_li3, __ul3_li3_a1, __ul3_li3_a1_span2, __insert4, __button5;

    __ = createElement("nav", null, null);
    __insert1 = createTextNode('', __);
    __a2 = createElement("a", "navbar-brand d-none d-md-inline-block", __);
    content(__a2, appCtrl.appName, "");
    __ul3 = createElement("ul", "navbar-nav mr-auto ml-n2 ml-md-0", __);
    __ul3_li1 = createElement("li", "nav-item", __ul3);
    __ul3_li1_a1 = createElement("a", "nav-link text-nowrap", __ul3_li1);
    createTextNode("🗓", __ul3_li1_a1);
    __ul3_li1_a1_span2 = createElement("span", "ml-sm-1 d-none d-sm-inline", __ul3_li1_a1);
    __ul3_li1_a1_span2.textContent = "Project Plan";
    __ul3_li2 = createElement("li", "nav-item", __ul3);
    __ul3_li2_a1 = createElement("a", "nav-link text-nowrap", __ul3_li2);
    createTextNode("⚠️", __ul3_li2_a1);
    __ul3_li2_a1_span2 = createElement("span", "ml-sm-1 d-none d-sm-inline", __ul3_li2_a1);
    __ul3_li2_a1_span2.textContent = "Warnings";
    __ul3_li2_a1_span3 = createElement("span", "badge badge-light badge-warning", __ul3_li2_a1);
    __ul3_li3 = createElement("li", "nav-item", __ul3);
    __ul3_li3_a1 = createElement("a", "nav-link text-nowrap", __ul3_li3);
    createTextNode("⚙️", __ul3_li3_a1);
    __ul3_li3_a1_span2 = createElement("span", "ml-sm-1 d-none d-sm-inline", __ul3_li3_a1);
    __ul3_li3_a1_span2.textContent = "Settings";
    __insert4 = createTextNode('', __);
    __button5 = createElement("button", "btn btn-sm btn-outline-secondary", __);
    S.effect(function (__range) {
      return insert(__range, ProgressBarView({
        "className": "progress-navbar",
        "progress": appCtrl.progress
      }));
    }, {
      start: __insert1,
      end: __insert1
    });
    S.effect(function () {
      __ul3_li1_a1.href = href(Page.HOME);
    });
    S.effect(function (__state) {
      return withClassIff(() => appCtrl.app.currentPage() === Page.HOME, 'active')(__ul3_li1, __state);
    });
    S.effect(function (__current) {
      return content(__ul3_li2_a1_span3, () => numWarnings(appCtrl), __current);
    }, '');
    S.effect(function (__state) {
      return withClassIff(() => numWarnings(appCtrl) === 0, 'd-none')(__ul3_li2_a1_span3, __state);
    });
    S.effect(function () {
      __ul3_li2_a1.href = href(Page.WARNINGS);
    });
    S.effect(function (__state) {
      return withClassIff(() => appCtrl.app.currentPage() === Page.WARNINGS, 'active')(__ul3_li2, __state);
    });
    S.effect(function () {
      __ul3_li3_a1.href = href(Page.SETTINGS);
    });
    S.effect(function (__state) {
      return withClassIff(() => appCtrl.app.currentPage() === Page.SETTINGS, 'active')(__ul3_li3, __state);
    });
    S.effect(function (__range) {
      return insert(__range, children);
    }, {
      start: __insert4,
      end: __insert4
    });
    S.effect(function (__current) {
      return content(__button5, labelFromAction(appCtrl.action()), __current);
    }, '');
    S.effect(function () {
      __button5.type = "button";

      __button5.onclick = () => appCtrl.defaultAction();
    });
    S.effect(function (__state) {
      return withClassIff(() => appCtrl.action() === Action.NOTHING, 'd-none')(__button5, __state);
    });
    S.effect(function () {
      __.className = append('navbar navbar-expand navbar-light bg-light', className);
    });
    return __;
  }();
}

function href(page) {
  return `#/${page}`;
}

function labelFromAction(action) {
  switch (action) {
    case Action.CONNECT:
      return 'Connect';

    case Action.BUILD_PLAN:
      return 'Build plan';

    case Action.UPDATE_PREDICTION:
      return 'Update prediction';

    case Action.STOP:
      return 'Stop';

    case Action.NOTHING:
      return 'Nothing';

    default:
      return unreachableCase(action);
  }
}

function numWarnings(appCtrl) {
  const extendedProjectPlan = appCtrl.extendedProjectPlan();
  return extendedProjectPlan === undefined ? 0 : extendedProjectPlan.plan.warnings.length;
}

export { NavView };
//# sourceMappingURL=nav-view.js.map
