import { createElement, S, setAttribute, assign } from 'surplus';
import { withClassIff } from '../../utils/surplus.js';

// noinspection ES6UnusedImports

function asString(progress, unit = '') {
  const currentProgress = progress();
  const value = currentProgress === undefined || currentProgress < 0 ? 0 : Math.min(100, currentProgress);
  return value === 0 ? value.toString() : `${value}${unit}`;
}

function ProgressBarView({
  className,
  progress
}) {
  return function () {
    var __, __div1;

    __ = createElement("div", null, null);
    __.className = `progress ${className || ''}`;
    __div1 = createElement("div", null, __);
    S.effect(function () {
      __div1.className = "progress-bar progress-bar-striped progress-bar-animated";
      setAttribute(__div1, "role", "progressbar");
      setAttribute(__div1, "aria-valuenow", asString(progress));
      setAttribute(__div1, "aria-valuemin", "0");
      setAttribute(__div1, "aria-valuemax", "100");
      assign(__div1.style, {
        width: asString(progress, '%')
      });
    });
    S.effect(function (__state) {
      return withClassIff(() => progress() === undefined, 'd-none')(__, __state);
    });
    return __;
  }();
}

export { ProgressBarView };
//# sourceMappingURL=progress-bar-view.js.map
