import { createElement, setAttribute, createTextNode, S, insert, content } from 'surplus';
import S$1 from 's-js';
import { bindString, bindStringSet, bindToOnValue } from '../../utils/surplus.js';
import { SettingsCtrl } from './settings-ctrl.js';
import { ContributorsView } from '../contributors/contributors-view.js';

const FORM_GROUP_CLASS = 'form-group row';
const LABEL_CLASS = 'col-form-label col-form-label-sm col-md-4 col-lg-3 text-md-right';
const INPUT_CLASS = 'form-control form-control-sm';
const SELECT_CLASS = 'custom-select custom-select-sm';
const EDIT_AREA_CLASS = 'col-md-8 col-lg-9';
const HELP_CLASS = 'form-text text-muted';
const CHECK_CLASS = 'form-check-input col-form-label-sm';
const CHECK_LABEL_CLASS = 'form-check-label col-form-label-sm';

function SinglePlaceholder({
  defaultPlaceholder,
  unknownIdPlaceholder,
  selectedId,
  choices,
  children
}) {
  const existsAsOption = choices.has(selectedId);
  let text = '';

  if (!existsAsOption && selectedId.length > 0) {
    text = unknownIdPlaceholder(selectedId);
  } else if (defaultPlaceholder !== undefined && selectedId.length === 0) {
    text = defaultPlaceholder;
  }

  if (text.length > 0) {
    children.innerText = text;
    return children;
  } else {
    return null;
  }
}

function multiplePlaceholders(selectedIds, choices, elementFactory) {
  return Array.from(selectedIds).filter(inactiveStateId => !choices.has(inactiveStateId)).map(elementFactory);
}

function SettingsView({
  ctrl
}) {
  return function () {
    var __, __div1, __div1_label1, __div1_div2, __div1_div2_input1, __div1_div2_small2, __hr2, __div3, __div3_label1, __div3_div2, __div3_div2_input1, __div3_div2_small2, __div3_div2_small2_code2, __div4, __div4_label1, __div4_div2, __div4_div2_input1, __div4_div2_small2, __div4_div2_small2_a2, __div5, __div5_div1, __div5_div1_button1, __div5_div1_small2, __div5_div1_small2_insert2, __div5_div1_small2_a4, __div5_div1_small2_a6, __hr6, __div7, __div7_label1, __div7_div2, __div7_div2_select1, __div7_div2_select1_insert1, __div7_div2_select1_insert2, __div7_div2_small2, __div8, __div8_label1, __div8_div2, __div8_div2_select1, __div8_div2_select1_insert1, __div8_div2_select1_insert2, __div8_div2_small2, __div9, __div9_label1, __div9_div2, __div9_div2_select1, __div9_div2_select1_insert1, __div9_div2_select1_insert2, __div9_div2_small2, __div10, __div10_label1, __div10_div2, __div10_div2_select1, __div10_div2_select1_option1, __div10_div2_select1_insert2, __div10_div2_small2, __div11, __div11_label1, __div11_div2, __div11_div2_select1, __div11_div2_select1_insert1, __div11_div2_select1_insert2, __div11_div2_small2, __div12, __div12_label1, __div12_div2, __div12_div2_select1, __div12_div2_select1_insert1, __div12_div2_select1_insert2, __div12_div2_small2, __div13, __div13_label1, __div13_div2, __div13_div2_select1, __div13_div2_select1_insert1, __div13_div2_select1_insert2, __div13_div2_small2, __div14, __div14_label1, __div14_div2, __div14_div2_select1, __div14_div2_select1_insert1, __div14_div2_select1_insert2, __div14_div2_small2, __div15, __div15_label1, __div15_fieldset2, __div15_fieldset2_div1, __div15_fieldset2_div1_input1, __div15_fieldset2_div1_label2, __div15_fieldset2_div1_label2_insert2, __div15_fieldset2_div2, __div15_fieldset2_div2_input1, __div15_fieldset2_div2_label2, __div15_fieldset2_div2_label2_insert2, __div15_fieldset2_small3, __div16, __div16_label1, __div16_div2, __div16_div2_select1, __div16_div2_select1_insert1, __div16_div2_select1_insert2, __div16_div2_small2, __div17, __div17_label1, __div17_div2, __div17_div2_select1, __div17_div2_select1_option1, __div17_div2_select1_insert2, __div17_div2_select1_insert3, __div17_div2_small2, __hr18, __div19, __div19_label1, __div19_insert2;

    __ = createElement("div", null, null);
    __div1 = createElement("div", null, __);
    __div1.className = FORM_GROUP_CLASS;
    __div1_label1 = createElement("label", null, __div1);
    __div1_label1.htmlFor = "instanceName";
    __div1_label1.className = LABEL_CLASS;
    __div1_label1.textContent = "Title:";
    __div1_div2 = createElement("div", null, __div1);
    __div1_div2.className = EDIT_AREA_CLASS;
    __div1_div2_input1 = createElement("input", null, __div1_div2);
    __div1_div2_input1.id = "instanceName";
    __div1_div2_input1.type = "text";
    __div1_div2_input1.className = INPUT_CLASS;
    setAttribute(__div1_div2_input1, "aria-describedby", "instanceNameHelp");
    __div1_div2_input1.placeholder = "Enter Name";
    __div1_div2_small2 = createElement("small", "form-text text-muted", __div1_div2);
    __div1_div2_small2.id = "instanceNameHelp";
    __div1_div2_small2.textContent = "The tab/window title, which is also used for bookmarks.";
    __hr2 = createElement("hr", null, __);
    __div3 = createElement("div", null, __);
    __div3.className = FORM_GROUP_CLASS;
    __div3_label1 = createElement("label", null, __div3);
    __div3_label1.htmlFor = "baseUrl";
    __div3_label1.className = LABEL_CLASS;
    __div3_label1.textContent = "Base URL:";
    __div3_div2 = createElement("div", null, __div3);
    __div3_div2.className = EDIT_AREA_CLASS;
    __div3_div2_input1 = createElement("input", null, __div3_div2);
    __div3_div2_input1.id = "baseUrl";
    __div3_div2_input1.type = "text";
    __div3_div2_input1.className = INPUT_CLASS;
    setAttribute(__div3_div2_input1, "aria-describedby", "baseUrlHelp");
    __div3_div2_input1.placeholder = "Enter URL";
    __div3_div2_small2 = createElement("small", "form-text text-muted", __div3_div2);
    __div3_div2_small2.id = "baseUrlHelp";
    createTextNode("For YouTrack InCloud, this is of form ", __div3_div2_small2);
    __div3_div2_small2_code2 = createElement("code", null, __div3_div2_small2);
    __div3_div2_small2_code2.textContent = "https://<name>.myjetbrains.com/";
    createTextNode(". For a YouTrack Standalone installation, this is the “Base URL” shown at Server Settings > Global Settings.", __div3_div2_small2);
    __div4 = createElement("div", null, __);
    __div4.className = FORM_GROUP_CLASS;
    __div4_label1 = createElement("label", null, __div4);
    __div4_label1.htmlFor = "serviceId";
    __div4_label1.className = LABEL_CLASS;
    __div4_label1.textContent = "Service ID in Hub:";
    __div4_div2 = createElement("div", null, __div4);
    __div4_div2.className = EDIT_AREA_CLASS;
    __div4_div2_input1 = createElement("input", null, __div4_div2);
    __div4_div2_input1.id = "serviceId";
    __div4_div2_input1.type = "text";
    __div4_div2_input1.className = INPUT_CLASS;
    setAttribute(__div4_div2_input1, "aria-describedby", "serviceIdHelp");
    __div4_div2_input1.placeholder = "Enter Service ID in Hub";
    __div4_div2_small2 = createElement("small", null, __div4_div2);
    __div4_div2_small2.id = "serviceIdHelp";
    __div4_div2_small2.className = HELP_CLASS;
    createTextNode("The YouTrack service ID is available via ", __div4_div2_small2);
    __div4_div2_small2_a2 = createElement("a", null, __div4_div2_small2);
    __div4_div2_small2_a2.target = "_blank";
    __div4_div2_small2_a2.textContent = "Server Settings > Hub Integration";
    createTextNode(".", __div4_div2_small2);
    __div5 = createElement("div", null, __);
    __div5.className = FORM_GROUP_CLASS;
    __div5_div1 = createElement("div", null, __div5);
    __div5_div1.className = `offset-md-4 offset-lg-3 ${EDIT_AREA_CLASS}`;
    __div5_div1_button1 = createElement("button", "btn btn-sm btn-secondary", __div5_div1);
    __div5_div1_small2 = createElement("small", null, __div5_div1);
    __div5_div1_small2.id = "loginHelp";
    __div5_div1_small2.className = HELP_CLASS;
    createTextNode("If you are not logged into YouTrack yet, this will take you to the YouTrack login page. Once logged in, you will be redirected back here. Please note: The URI of this web app (that is, “", __div5_div1_small2);
    __div5_div1_small2_insert2 = createTextNode('', __div5_div1_small2);
    createTextNode("”) needs to be registered in the ", __div5_div1_small2);
    __div5_div1_small2_a4 = createElement("a", null, __div5_div1_small2);
    __div5_div1_small2_a4.target = "_blank";
    __div5_div1_small2_a4.textContent = "Hub Settings";
    createTextNode(" under “Redirect URIs”. The URI also needs to be added under “Allowed origins” at ", __div5_div1_small2);
    __div5_div1_small2_a6 = createElement("a", null, __div5_div1_small2);
    __div5_div1_small2_a6.target = "_blank";
    __div5_div1_small2_a6.textContent = "Server Settings > Global Settings";
    createTextNode(".", __div5_div1_small2);
    __hr6 = createElement("hr", null, __);
    __div7 = createElement("div", null, __);
    __div7.className = FORM_GROUP_CLASS;
    __div7_label1 = createElement("label", null, __div7);
    __div7_label1.htmlFor = "stateField";
    __div7_label1.className = LABEL_CLASS;
    __div7_label1.textContent = "State Field:";
    __div7_div2 = createElement("div", null, __div7);
    __div7_div2.className = EDIT_AREA_CLASS;
    __div7_div2_select1 = createElement("select", null, __div7_div2);
    __div7_div2_select1.id = "stateField";
    __div7_div2_select1.className = SELECT_CLASS;
    setAttribute(__div7_div2_select1, "aria-describedby", "stateFieldHelp");
    __div7_div2_select1_insert1 = createTextNode('', __div7_div2_select1);
    __div7_div2_select1_insert2 = createTextNode('', __div7_div2_select1);
    __div7_div2_small2 = createElement("small", null, __div7_div2);
    __div7_div2_small2.id = "stateFieldHelp";
    __div7_div2_small2.className = HELP_CLASS;
    __div7_div2_small2.textContent = "The custom field (of type state) that contains the issue state.";
    __div8 = createElement("div", null, __);
    __div8.className = FORM_GROUP_CLASS;
    __div8_label1 = createElement("label", null, __div8);
    __div8_label1.htmlFor = "inactiveStates";
    __div8_label1.className = LABEL_CLASS;
    __div8_label1.textContent = "Inactive States:";
    __div8_div2 = createElement("div", null, __div8);
    __div8_div2.className = EDIT_AREA_CLASS;
    __div8_div2_select1 = createElement("select", null, __div8_div2);
    __div8_div2_select1.id = "inactiveStates";
    __div8_div2_select1.className = SELECT_CLASS;
    __div8_div2_select1.multiple = true;
    setAttribute(__div8_div2_select1, "aria-describedby", "inactiveStatesHelp");
    __div8_div2_select1_insert1 = createTextNode('', __div8_div2_select1);
    __div8_div2_select1_insert2 = createTextNode('', __div8_div2_select1);
    __div8_div2_small2 = createElement("small", null, __div8_div2);
    __div8_div2_small2.id = "inactiveStatesHelp";
    __div8_div2_small2.className = HELP_CLASS;
    __div8_div2_small2.textContent = "The unresolved states indicating an issue should appear as inactive.";
    __div9 = createElement("div", null, __);
    __div9.className = FORM_GROUP_CLASS;
    __div9_label1 = createElement("label", null, __div9);
    __div9_label1.htmlFor = "remainingEffortField";
    __div9_label1.className = LABEL_CLASS;
    __div9_label1.textContent = "Remaining Effort Field:";
    __div9_div2 = createElement("div", null, __div9);
    __div9_div2.className = EDIT_AREA_CLASS;
    __div9_div2_select1 = createElement("select", null, __div9_div2);
    __div9_div2_select1.id = "remainingEffortField";
    __div9_div2_select1.className = SELECT_CLASS;
    setAttribute(__div9_div2_select1, "aria-describedby", "remainingEffortFieldHelp");
    __div9_div2_select1_insert1 = createTextNode('', __div9_div2_select1);
    __div9_div2_select1_insert2 = createTextNode('', __div9_div2_select1);
    __div9_div2_small2 = createElement("small", null, __div9_div2);
    __div9_div2_small2.id = "remainingEffortFieldHelp";
    __div9_div2_small2.className = HELP_CLASS;
    __div9_div2_small2.textContent = "The custom field (of type period) that contains the remaining effort.";
    __div10 = createElement("div", null, __);
    __div10.className = FORM_GROUP_CLASS;
    __div10_label1 = createElement("label", null, __div10);
    __div10_label1.htmlFor = "remainingWaitField";
    __div10_label1.className = LABEL_CLASS;
    __div10_label1.textContent = "Remaining Wait Field:";
    __div10_div2 = createElement("div", null, __div10);
    __div10_div2.className = EDIT_AREA_CLASS;
    __div10_div2_select1 = createElement("select", null, __div10_div2);
    __div10_div2_select1.id = "remainingWaitField";
    __div10_div2_select1.className = SELECT_CLASS;
    setAttribute(__div10_div2_select1, "aria-describedby", "remainingWaitFieldHelp");
    __div10_div2_select1_option1 = createElement("option", null, __div10_div2_select1);
    __div10_div2_select1_option1.value = "";
    __div10_div2_select1_option1.textContent = "None";
    __div10_div2_select1_insert2 = createTextNode('', __div10_div2_select1);
    __div10_div2_small2 = createElement("small", null, __div10_div2);
    __div10_div2_small2.id = "remainingWaitFieldHelp";
    __div10_div2_small2.className = HELP_CLASS;
    __div10_div2_small2.textContent = "The custom field (of type period) that contains the remaining wait.";
    __div11 = createElement("div", null, __);
    __div11.className = FORM_GROUP_CLASS;
    __div11_label1 = createElement("label", null, __div11);
    __div11_label1.htmlFor = "assigneeField";
    __div11_label1.className = LABEL_CLASS;
    __div11_label1.textContent = "Assignee Field:";
    __div11_div2 = createElement("div", null, __div11);
    __div11_div2.className = EDIT_AREA_CLASS;
    __div11_div2_select1 = createElement("select", null, __div11_div2);
    __div11_div2_select1.id = "assigneeField";
    __div11_div2_select1.className = SELECT_CLASS;
    setAttribute(__div11_div2_select1, "aria-describedby", "assigneeFieldHelp");
    __div11_div2_select1_insert1 = createTextNode('', __div11_div2_select1);
    __div11_div2_select1_insert2 = createTextNode('', __div11_div2_select1);
    __div11_div2_small2 = createElement("small", null, __div11_div2);
    __div11_div2_small2.id = "stateFieldHelp";
    __div11_div2_small2.className = HELP_CLASS;
    __div11_div2_small2.textContent = "The custom field (of type user) that contains the assignee.";
    __div12 = createElement("div", null, __);
    __div12.className = FORM_GROUP_CLASS;
    __div12_label1 = createElement("label", null, __div12);
    __div12_label1.htmlFor = "typeField";
    __div12_label1.className = LABEL_CLASS;
    __div12_label1.textContent = "Type Field:";
    __div12_div2 = createElement("div", null, __div12);
    __div12_div2.className = EDIT_AREA_CLASS;
    __div12_div2_select1 = createElement("select", null, __div12_div2);
    __div12_div2_select1.id = "typeField";
    __div12_div2_select1.className = SELECT_CLASS;
    setAttribute(__div12_div2_select1, "aria-describedby", "typeFieldHelp");
    __div12_div2_select1_insert1 = createTextNode('', __div12_div2_select1);
    __div12_div2_select1_insert2 = createTextNode('', __div12_div2_select1);
    __div12_div2_small2 = createElement("small", null, __div12_div2);
    __div12_div2_small2.id = "typeFieldHelp";
    __div12_div2_small2.className = HELP_CLASS;
    __div12_div2_small2.textContent = "The custom field (of type enum) that contains the issue type.";
    __div13 = createElement("div", null, __);
    __div13.className = FORM_GROUP_CLASS;
    __div13_label1 = createElement("label", null, __div13);
    __div13_label1.htmlFor = "splittableTypes";
    __div13_label1.className = LABEL_CLASS;
    __div13_label1.textContent = "Splittable Types:";
    __div13_div2 = createElement("div", null, __div13);
    __div13_div2.className = EDIT_AREA_CLASS;
    __div13_div2_select1 = createElement("select", null, __div13_div2);
    __div13_div2_select1.id = "splittableTypes";
    __div13_div2_select1.className = SELECT_CLASS;
    __div13_div2_select1.multiple = true;
    setAttribute(__div13_div2_select1, "aria-describedby", "splittableTypesHelp");
    __div13_div2_select1_insert1 = createTextNode('', __div13_div2_select1);
    __div13_div2_select1_insert2 = createTextNode('', __div13_div2_select1);
    __div13_div2_small2 = createElement("small", null, __div13_div2);
    __div13_div2_small2.id = "splittableTypesHelp";
    __div13_div2_small2.className = HELP_CLASS;
    __div13_div2_small2.textContent = "The issue types that allow splitting across multiple persons when planning.";
    __div14 = createElement("div", null, __);
    __div14.className = FORM_GROUP_CLASS;
    __div14_label1 = createElement("label", null, __div14);
    __div14_label1.htmlFor = "dependsLinkType";
    __div14_label1.className = LABEL_CLASS;
    __div14_label1.textContent = "Dependency Link:";
    __div14_div2 = createElement("div", null, __div14);
    __div14_div2.className = EDIT_AREA_CLASS;
    __div14_div2_select1 = createElement("select", null, __div14_div2);
    __div14_div2_select1.id = "dependsLinkType";
    __div14_div2_select1.className = SELECT_CLASS;
    setAttribute(__div14_div2_select1, "aria-describedby", "dependsLinkTypeHelp");
    __div14_div2_select1_insert1 = createTextNode('', __div14_div2_select1);
    __div14_div2_select1_insert2 = createTextNode('', __div14_div2_select1);
    __div14_div2_small2 = createElement("small", null, __div14_div2);
    __div14_div2_small2.id = "dependsLinkTypeHelp";
    __div14_div2_small2.className = HELP_CLASS;
    __div14_div2_small2.textContent = "The type of issue link that indicates a finish-to-start dependency.";
    __div15 = createElement("div", null, __);
    __div15.className = FORM_GROUP_CLASS;
    __div15_label1 = createElement("label", null, __div15);
    __div15_label1.htmlFor = "doesInwardDependOnOutward";
    __div15_label1.className = LABEL_CLASS;
    __div15_label1.textContent = "A before B:";
    __div15_fieldset2 = createElement("fieldset", null, __div15);
    __div15_fieldset2.id = "doesInwardDependOnOutward";
    __div15_fieldset2.className = EDIT_AREA_CLASS;
    setAttribute(__div15_fieldset2, "aria-describedby", "doesInwardDependOnOutwardHelp");
    __div15_fieldset2_div1 = createElement("div", "form-check form-check-inline", __div15_fieldset2);
    __div15_fieldset2_div1_input1 = createElement("input", null, __div15_fieldset2_div1);
    __div15_fieldset2_div1_input1.className = CHECK_CLASS;
    __div15_fieldset2_div1_input1.type = "radio";
    __div15_fieldset2_div1_input1.id = "gridRadios1";
    __div15_fieldset2_div1_label2 = createElement("label", null, __div15_fieldset2_div1);
    __div15_fieldset2_div1_label2.className = CHECK_LABEL_CLASS;
    __div15_fieldset2_div1_label2.htmlFor = "gridRadios1";
    createTextNode("A ", __div15_fieldset2_div1_label2);
    __div15_fieldset2_div1_label2_insert2 = createTextNode('', __div15_fieldset2_div1_label2);
    createTextNode(" B", __div15_fieldset2_div1_label2);
    __div15_fieldset2_div2 = createElement("div", "form-check form-check-inline", __div15_fieldset2);
    __div15_fieldset2_div2_input1 = createElement("input", null, __div15_fieldset2_div2);
    __div15_fieldset2_div2_input1.className = CHECK_CLASS;
    __div15_fieldset2_div2_input1.type = "radio";
    __div15_fieldset2_div2_input1.id = "gridRadios2";
    __div15_fieldset2_div2_label2 = createElement("label", null, __div15_fieldset2_div2);
    __div15_fieldset2_div2_label2.className = CHECK_LABEL_CLASS;
    __div15_fieldset2_div2_label2.htmlFor = "gridRadios2";
    createTextNode("A ", __div15_fieldset2_div2_label2);
    __div15_fieldset2_div2_label2_insert2 = createTextNode('', __div15_fieldset2_div2_label2);
    createTextNode(" B", __div15_fieldset2_div2_label2);
    __div15_fieldset2_small3 = createElement("small", null, __div15_fieldset2);
    __div15_fieldset2_small3.id = "doesInwardDependOnOutwardHelp";
    __div15_fieldset2_small3.className = HELP_CLASS;
    __div15_fieldset2_small3.textContent = "The side of a dependency link synonymous with “needs to be finished before”.";
    __div16 = createElement("div", null, __);
    __div16.className = FORM_GROUP_CLASS;
    __div16_label1 = createElement("label", null, __div16);
    __div16_label1.htmlFor = "savedQuery";
    __div16_label1.className = LABEL_CLASS;
    __div16_label1.textContent = "Saved Query:";
    __div16_div2 = createElement("div", null, __div16);
    __div16_div2.className = EDIT_AREA_CLASS;
    __div16_div2_select1 = createElement("select", null, __div16_div2);
    __div16_div2_select1.id = "savedQuery";
    __div16_div2_select1.className = SELECT_CLASS;
    setAttribute(__div16_div2_select1, "aria-describedby", "savedQueryHelp");
    __div16_div2_select1_insert1 = createTextNode('', __div16_div2_select1);
    __div16_div2_select1_insert2 = createTextNode('', __div16_div2_select1);
    __div16_div2_small2 = createElement("small", null, __div16_div2);
    __div16_div2_small2.id = "savedQueryHelp";
    __div16_div2_small2.className = HELP_CLASS;
    __div16_div2_small2.textContent = "The saved search containing the issues that will comprise the project plan. Issues will be scheduled in the order of this saved search (unless also part of the overlay saved search).";
    __div17 = createElement("div", null, __);
    __div17.className = FORM_GROUP_CLASS;
    __div17_label1 = createElement("label", null, __div17);
    __div17_label1.htmlFor = "overlaySavedQuery";
    __div17_label1.className = LABEL_CLASS;
    __div17_label1.textContent = "Overlay:";
    __div17_div2 = createElement("div", null, __div17);
    __div17_div2.className = EDIT_AREA_CLASS;
    __div17_div2_select1 = createElement("select", null, __div17_div2);
    __div17_div2_select1.id = "overlaySavedQuery";
    __div17_div2_select1.className = SELECT_CLASS;
    setAttribute(__div17_div2_select1, "aria-describedby", "overlaySavedQueryHelp");
    __div17_div2_select1_option1 = createElement("option", null, __div17_div2_select1);
    __div17_div2_select1_option1.value = "";
    __div17_div2_select1_option1.textContent = "None";
    __div17_div2_select1_insert2 = createTextNode('', __div17_div2_select1);
    __div17_div2_select1_insert3 = createTextNode('', __div17_div2_select1);
    __div17_div2_small2 = createElement("small", null, __div17_div2);
    __div17_div2_small2.id = "overlaySavedQuery";
    __div17_div2_small2.className = HELP_CLASS;
    __div17_div2_small2.textContent = "Reorders the issues that are contained in both saved searches according to this overlay. The order (more precisely, the rank) of all issues not contained in this overlay remains the same.";
    __hr18 = createElement("hr", null, __);
    __div19 = createElement("div", null, __);
    __div19.className = FORM_GROUP_CLASS;
    __div19_label1 = createElement("label", null, __div19);
    __div19_label1.className = LABEL_CLASS;
    __div19_label1.textContent = "Contributors:";
    __div19_insert2 = createTextNode('', __div19);
    S.effect(function (__state) {
      return bindString(ctrl.settings.name)(__div1_div2_input1, __state);
    });
    S.effect(function (__state) {
      return bindString(ctrl.settings.youTrackBaseUrl)(__div3_div2_input1, __state);
    });
    S.effect(function (__state) {
      return bindString(ctrl.settings.youTrackServiceId)(__div4_div2_input1, __state);
    });
    S.effect(function (__state) {
      return ctrl.hrefRelativeToBaseUrl('youtrack/admin/ring')(__div4_div2_small2_a2, __state);
    });
    S.effect(function () {
      __div5_div1_button1.type = "button";
      setAttribute(__div5_div1_button1, "aria-describedby", "loginHelp");
      __div5_div1_button1.disabled = ctrl.verifiedBaseUrl().length === 0 || ctrl.settings.youTrackServiceId().length === 0;

      __div5_div1_button1.onclick = () => ctrl.connectSignal(null);

      __div5_div1_button1.textContent = "Connect…";
    });
    S.effect(function (__range) {
      return insert(__range, SettingsCtrl.currentUri());
    }, {
      start: __div5_div1_small2_insert2,
      end: __div5_div1_small2_insert2
    });
    S.effect(function (__state) {
      return ctrl.hubRelativeToBaseUrlAndServiceId(serviceId => `youtrack/admin/hub/services/${serviceId}?tab=settings`)(__div5_div1_small2_a4, __state);
    });
    S.effect(function (__state) {
      return ctrl.hrefRelativeToBaseUrl('youtrack/admin/settings')(__div5_div1_small2_a6, __state);
    });
    S.effect(function (__range) {
      return insert(__range, SinglePlaceholder({
        "defaultPlaceholder": "None selected",
        "unknownIdPlaceholder": unknownId => `Unknown (ID: ${unknownId})`,
        "selectedId": ctrl.settings.stateFieldId(),
        "choices": ctrl.stateFields(),
        "children": function () {
          var __;

          __ = createElement("option", null, null);
          S.effect(function () {
            __.value = ctrl.settings.stateFieldId();
            __.selected = true;
            __.disabled = true;
          });
          return __;
        }()
      }));
    }, {
      start: __div7_div2_select1_insert1,
      end: __div7_div2_select1_insert1
    });
    S.effect(function (__range) {
      return insert(__range, Array.from(ctrl.stateFields().values(), customField => function () {
        var __;

        __ = createElement("option", null, null);
        content(__, customField.name, "");
        S.effect(function () {
          __.value = customField.id;
          __.selected = customField.id === S$1.sample(ctrl.settings.stateFieldId);
        });
        return __;
      }()));
    }, {
      start: __div7_div2_select1_insert2,
      end: __div7_div2_select1_insert2
    });
    S.effect(function (__state) {
      return bindString(ctrl.settings.stateFieldId)(__div7_div2_select1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, multiplePlaceholders(ctrl.settings.inactiveStateIds(), ctrl.states(), inactiveStateId => function () {
        var __, __insert2;

        __ = createElement("option", null, null);
        __.value = inactiveStateId;
        __.selected = true;
        __.disabled = true;
        createTextNode("Unknown (ID: ", __);
        __insert2 = createTextNode('', __);
        createTextNode(")", __);
        S.effect(function (__range) {
          return insert(__range, inactiveStateId);
        }, {
          start: __insert2,
          end: __insert2
        });
        return __;
      }()));
    }, {
      start: __div8_div2_select1_insert1,
      end: __div8_div2_select1_insert1
    });
    S.effect(function (__range) {
      return insert(__range, Array.from(ctrl.states().values(), stateBundleElement => function () {
        var __;

        __ = createElement("option", null, null);
        content(__, stateBundleElement.name, "");
        S.effect(function () {
          __.value = stateBundleElement.id;
          __.selected = S$1.sample(ctrl.settings.inactiveStateIds).has(stateBundleElement.id);
        });
        return __;
      }()));
    }, {
      start: __div8_div2_select1_insert2,
      end: __div8_div2_select1_insert2
    });
    S.effect(function (__state) {
      return bindStringSet(ctrl.settings.inactiveStateIds)(__div8_div2_select1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, SinglePlaceholder({
        "defaultPlaceholder": "None selected",
        "unknownIdPlaceholder": unknownId => `Unknown (ID: ${unknownId})`,
        "selectedId": ctrl.settings.remainingEffortFieldId(),
        "choices": ctrl.periodFields(),
        "children": function () {
          var __;

          __ = createElement("option", null, null);
          S.effect(function () {
            __.value = ctrl.settings.remainingEffortFieldId();
            __.selected = true;
            __.disabled = true;
          });
          return __;
        }()
      }));
    }, {
      start: __div9_div2_select1_insert1,
      end: __div9_div2_select1_insert1
    });
    S.effect(function (__range) {
      return insert(__range, Array.from(ctrl.periodFields().values(), customField => function () {
        var __;

        __ = createElement("option", null, null);
        content(__, customField.name, "");
        S.effect(function () {
          __.value = customField.id;
          __.selected = customField.id === S$1.sample(ctrl.settings.remainingEffortFieldId);
        });
        return __;
      }()));
    }, {
      start: __div9_div2_select1_insert2,
      end: __div9_div2_select1_insert2
    });
    S.effect(function (__state) {
      return bindString(ctrl.settings.remainingEffortFieldId)(__div9_div2_select1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, Array.from(ctrl.periodFields().values(), customField => function () {
        var __;

        __ = createElement("option", null, null);
        content(__, customField.name, "");
        S.effect(function () {
          __.value = customField.id;
          __.selected = customField.id === S$1.sample(ctrl.settings.remainingWaitFieldId);
        });
        return __;
      }()));
    }, {
      start: __div10_div2_select1_insert2,
      end: __div10_div2_select1_insert2
    });
    S.effect(function (__state) {
      return bindString(ctrl.settings.remainingWaitFieldId)(__div10_div2_select1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, SinglePlaceholder({
        "defaultPlaceholder": "None selected",
        "unknownIdPlaceholder": unknownId => `Unknown (ID: ${unknownId})`,
        "selectedId": ctrl.settings.assigneeFieldId(),
        "choices": ctrl.userFields(),
        "children": function () {
          var __;

          __ = createElement("option", null, null);
          S.effect(function () {
            __.value = ctrl.settings.assigneeFieldId();
            __.selected = true;
            __.disabled = true;
          });
          return __;
        }()
      }));
    }, {
      start: __div11_div2_select1_insert1,
      end: __div11_div2_select1_insert1
    });
    S.effect(function (__range) {
      return insert(__range, Array.from(ctrl.userFields().values(), customField => function () {
        var __;

        __ = createElement("option", null, null);
        content(__, customField.name, "");
        S.effect(function () {
          __.value = customField.id;
          __.selected = customField.id === S$1.sample(ctrl.settings.assigneeFieldId);
        });
        return __;
      }()));
    }, {
      start: __div11_div2_select1_insert2,
      end: __div11_div2_select1_insert2
    });
    S.effect(function (__state) {
      return bindString(ctrl.settings.assigneeFieldId)(__div11_div2_select1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, SinglePlaceholder({
        "defaultPlaceholder": "None selected",
        "unknownIdPlaceholder": unknownId => `Unknown (ID: ${unknownId})`,
        "selectedId": ctrl.settings.typeFieldId(),
        "choices": ctrl.enumFields(),
        "children": function () {
          var __;

          __ = createElement("option", null, null);
          S.effect(function () {
            __.value = ctrl.settings.typeFieldId();
            __.selected = true;
            __.disabled = true;
          });
          return __;
        }()
      }));
    }, {
      start: __div12_div2_select1_insert1,
      end: __div12_div2_select1_insert1
    });
    S.effect(function (__range) {
      return insert(__range, Array.from(ctrl.enumFields().values(), customField => function () {
        var __;

        __ = createElement("option", null, null);
        content(__, customField.name, "");
        S.effect(function () {
          __.value = customField.id;
          __.selected = customField.id === S$1.sample(ctrl.settings.typeFieldId);
        });
        return __;
      }()));
    }, {
      start: __div12_div2_select1_insert2,
      end: __div12_div2_select1_insert2
    });
    S.effect(function (__state) {
      return bindString(ctrl.settings.typeFieldId)(__div12_div2_select1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, multiplePlaceholders(ctrl.settings.splittableTypeIds(), ctrl.types(), typeId => function () {
        var __, __insert2;

        __ = createElement("option", null, null);
        __.value = typeId;
        __.selected = true;
        __.disabled = true;
        createTextNode("Unknown (ID: ", __);
        __insert2 = createTextNode('', __);
        createTextNode(")", __);
        S.effect(function (__range) {
          return insert(__range, typeId);
        }, {
          start: __insert2,
          end: __insert2
        });
        return __;
      }()));
    }, {
      start: __div13_div2_select1_insert1,
      end: __div13_div2_select1_insert1
    });
    S.effect(function (__range) {
      return insert(__range, Array.from(ctrl.types().values(), enumBundleElement => function () {
        var __;

        __ = createElement("option", null, null);
        content(__, enumBundleElement.name, "");
        S.effect(function () {
          __.value = enumBundleElement.id;
          __.selected = S$1.sample(ctrl.settings.splittableTypeIds).has(enumBundleElement.id);
        });
        return __;
      }()));
    }, {
      start: __div13_div2_select1_insert2,
      end: __div13_div2_select1_insert2
    });
    S.effect(function (__state) {
      return bindStringSet(ctrl.settings.splittableTypeIds)(__div13_div2_select1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, SinglePlaceholder({
        "defaultPlaceholder": "None selected",
        "unknownIdPlaceholder": unknownId => `Unknown (ID: ${unknownId})`,
        "selectedId": ctrl.settings.dependsLinkTypeId(),
        "choices": ctrl.directedIssueLinkTypes(),
        "children": function () {
          var __;

          __ = createElement("option", null, null);
          S.effect(function () {
            __.value = ctrl.settings.dependsLinkTypeId();
            __.selected = true;
            __.disabled = true;
          });
          return __;
        }()
      }));
    }, {
      start: __div14_div2_select1_insert1,
      end: __div14_div2_select1_insert1
    });
    S.effect(function (__range) {
      return insert(__range, Array.from(ctrl.directedIssueLinkTypes().values(), linkType => function () {
        var __, __insert1, __insert3, __insert5;

        __ = createElement("option", null, null);
        __insert1 = createTextNode('', __);
        createTextNode(" (", __);
        __insert3 = createTextNode('', __);
        createTextNode(" → ", __);
        __insert5 = createTextNode('', __);
        createTextNode(")", __);
        S.effect(function (__range) {
          return insert(__range, linkType.name);
        }, {
          start: __insert1,
          end: __insert1
        });
        S.effect(function (__range) {
          return insert(__range, linkType.sourceToTarget);
        }, {
          start: __insert3,
          end: __insert3
        });
        S.effect(function (__range) {
          return insert(__range, linkType.targetToSource);
        }, {
          start: __insert5,
          end: __insert5
        });
        S.effect(function () {
          __.value = linkType.id;
          __.selected = linkType.id === S$1.sample(ctrl.settings.dependsLinkTypeId);
        });
        return __;
      }()));
    }, {
      start: __div14_div2_select1_insert2,
      end: __div14_div2_select1_insert2
    });
    S.effect(function (__state) {
      return bindString(ctrl.settings.dependsLinkTypeId)(__div14_div2_select1, __state);
    });
    S.effect(function (__state) {
      return bindToOnValue(ctrl.settings.doesInwardDependOnOutward, true)(__div15_fieldset2_div1_input1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, ctrl.issueLinkDirectionNames()[0]);
    }, {
      start: __div15_fieldset2_div1_label2_insert2,
      end: __div15_fieldset2_div1_label2_insert2
    });
    S.effect(function (__state) {
      return bindToOnValue(ctrl.settings.doesInwardDependOnOutward, false)(__div15_fieldset2_div2_input1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, ctrl.issueLinkDirectionNames()[1]);
    }, {
      start: __div15_fieldset2_div2_label2_insert2,
      end: __div15_fieldset2_div2_label2_insert2
    });
    S.effect(function (__range) {
      return insert(__range, SinglePlaceholder({
        "defaultPlaceholder": "None selected",
        "unknownIdPlaceholder": unknownId => `Unknown (ID: ${unknownId})`,
        "selectedId": ctrl.settings.savedQuery(),
        "choices": ctrl.savedQueryIds(),
        "children": function () {
          var __;

          __ = createElement("option", null, null);
          S.effect(function () {
            __.value = ctrl.settings.savedQuery();
            __.selected = true;
            __.disabled = true;
          });
          return __;
        }()
      }));
    }, {
      start: __div16_div2_select1_insert1,
      end: __div16_div2_select1_insert1
    });
    S.effect(function (__range) {
      return insert(__range, ctrl.metadata().savedSearches.map(savedSearch => function () {
        var __, __insert1, __insert3;

        __ = createElement("option", null, null);
        __insert1 = createTextNode('', __);
        createTextNode(" (", __);
        __insert3 = createTextNode('', __);
        createTextNode(")", __);
        S.effect(function (__range) {
          return insert(__range, savedSearch.name);
        }, {
          start: __insert1,
          end: __insert1
        });
        S.effect(function (__range) {
          return insert(__range, savedSearch.owner.fullName);
        }, {
          start: __insert3,
          end: __insert3
        });
        S.effect(function () {
          __.value = savedSearch.id;
          __.selected = savedSearch.id === S$1.sample(ctrl.settings.savedQuery);
        });
        return __;
      }()));
    }, {
      start: __div16_div2_select1_insert2,
      end: __div16_div2_select1_insert2
    });
    S.effect(function (__state) {
      return bindString(ctrl.settings.savedQuery)(__div16_div2_select1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, SinglePlaceholder({
        "unknownIdPlaceholder": unknownId => `Unknown (ID: ${unknownId})`,
        "selectedId": ctrl.settings.overlaySavedQuery(),
        "choices": ctrl.savedQueryIds(),
        "children": function () {
          var __;

          __ = createElement("option", null, null);
          S.effect(function () {
            __.value = ctrl.settings.overlaySavedQuery();
            __.selected = true;
            __.disabled = true;
          });
          return __;
        }()
      }));
    }, {
      start: __div17_div2_select1_insert2,
      end: __div17_div2_select1_insert2
    });
    S.effect(function (__range) {
      return insert(__range, ctrl.metadata().savedSearches.map(overlaySavedQuery => function () {
        var __, __insert1, __insert3;

        __ = createElement("option", null, null);
        __insert1 = createTextNode('', __);
        createTextNode(" (", __);
        __insert3 = createTextNode('', __);
        createTextNode(")", __);
        S.effect(function (__range) {
          return insert(__range, overlaySavedQuery.name);
        }, {
          start: __insert1,
          end: __insert1
        });
        S.effect(function (__range) {
          return insert(__range, overlaySavedQuery.owner.fullName);
        }, {
          start: __insert3,
          end: __insert3
        });
        S.effect(function () {
          __.value = overlaySavedQuery.id;
          __.selected = overlaySavedQuery.id === S$1.sample(ctrl.settings.overlaySavedQuery);
          __.disabled = overlaySavedQuery.id === ctrl.settings.savedQuery();
        });
        return __;
      }()));
    }, {
      start: __div17_div2_select1_insert3,
      end: __div17_div2_select1_insert3
    });
    S.effect(function (__state) {
      return bindString(ctrl.settings.overlaySavedQuery)(__div17_div2_select1, __state);
    });
    S.effect(function (__range) {
      return insert(__range, ContributorsView({
        "className": EDIT_AREA_CLASS,
        "ctrl": ctrl.contributorsCtrl
      }));
    }, {
      start: __div19_insert2,
      end: __div19_insert2
    });
    return __;
  }();
}

export { SettingsView };
//# sourceMappingURL=settings-view.js.map
